local mod = ...



-- Building Part: Trapper's Tent -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ESSENTIALS_TRAPPER",
	Name = "BUILDING_PART_ESSENTIALS_TRAPPER_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ESSENTIALS_TRAPPER",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0.0,
            CameraPosition = { 0, 1, -12 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 0.0
        },
	},
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createRectangle( {3.5, 2.5}, {0, 0} ),
				Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ESSENTIALS_TRAPPER",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 1 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})



-- Job: Trapper -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_ESSENTIALS_TRAPPER",
	JobName = "JOB_ESSENTIALS_TRAPPER_NAME",
	JobDescription = "JOB_ESSENTIALS_TRAPPER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 30.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	RelatedZone = "HUNTING",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        -- FemaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_FRONT",
        -- },
        -- FemaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_BELT",
        -- },
        -- MaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_FRONT",
        -- },
        -- MaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_BELT",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "MILK"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ESSENTIALS_TRAPPER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ESSENTIALS_TRAPPER"
    }
})



-- Resource: Boar (Override) -------------------------------------------------------------------------------------
mod:registerEnumValue ("RESOURCE_TYPE", "RESOURCE_TYPE_GAME")

mod:override({
	Id = "BOAR",
	ResourceName = "RESOURCE_ESSENTIALS_BOAR_NAME",
	ResourceTypeList = {
		Action = "APPEND",
		"RESOURCE_TYPE_GAME"
	}
})



-- Building Function: Trapper -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ESSENTIALS_TRAPPER",
	Name = "BUILDING_FUNCTION_ESSENTIALS_TRAPPER_NAME",
	IsPrivate = false,
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_ESSENTIALS_TRAPPER", 
        Behavior = "BEHAVIOR_GATHER"
	},
	TypeList = { "RESOURCE_TYPE_GAME" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 20,
	InputInventoryCapacity = {
		{ Resource = "BOAR", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "BOAR", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "BOAR", Quantity = 1 },
	}
})



-- Zone: Hunting (Override) -------------------------------------------------------------------------------------
mod:override({
	Id = "HUNTING",
	Description = "HUNTING_DESC",
	IsLockedByDefault = false
})
